Index: /trunk/workflow/inc/class.so_orgchart.inc.php
===================================================================
--- /trunk/workflow/inc/class.so_orgchart.inc.php	(revision 6490)
+++ /trunk/workflow/inc/class.so_orgchart.inc.php	(revision 6535)
@@ -128,5 +128,4 @@
 		$this->acl = &$GLOBALS['ajax']->acl;
 		$this->db = &Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Link_ID;
-		$this->db = &Factory::getInstance('WorkflowObjects')->getDBWorkflow()->Link_ID;
 		$this->db->SetFetchMode(ADODB_FETCH_ASSOC);
 	}
@@ -835,5 +834,8 @@
 	{
 		$this->_checkAccess($organizationID);
-		$this->validateDate($admDate);
+		if ($admDate!='')
+			$this->validateDate($admDate);
+		else
+			$admDate=NULL;
 
 		$query = 'SELECT area.sigla FROM funcionario, area WHERE (funcionario.area_id = area.area_id) AND (funcionario.funcionario_id = ?)';
@@ -876,10 +878,15 @@
 	{
 		$this->_checkAccess($organizationID);
-		$this->validateDate($admDate);
+		if ($admDate!='')
+			$this->validateDate($admDate);
+		else
+			$admDate=NULL;
 		
-		$query = "UPDATE funcionario SET area_id = ?, centro_custo_id = ?, localidade_id = ?, funcionario_status_id = ?, cargo_id = ?, nivel = ?, funcionario_categoria_id = ?, titulo = ?, apelido = ?, funcao = ?, data_admissao = ? WHERE (funcionario_id = ?) AND (organizacao_id = ?)";
-		$result = $this->db->query($query, array($areaID, $costCenterID, $localID, $employeeStatusID, $jobTitleID, $level, $employeeCategoryID, $title,$nickname, $jobDesc, $admDate, $employeeID, $organizationID));
-		$this->_checkError($result);
-
+		$query = "UPDATE funcionario SET area_id = ?, centro_custo_id = ?, localidade_id = ?, funcionario_status_id = ?, cargo_id = ?, nivel = ?, funcionario_categoria_id = ?, titulo = ?, apelido = ?, funcao = ?, data_admissao =? WHERE (funcionario_id = ?) AND (organizacao_id = ?)";
+			
+		$result = $this->db->query($query, array($areaID, $costCenterID, $localID, $employeeStatusID, $jobTitleID, $level, $employeeCategoryID, $title,$nickname, $jobDesc,$admDate, $employeeID, $organizationID));
+		
+		$this->_checkError($result);
+		
 		return (($result === false) ? false : true);
 	}
Index: /trunk/workflow/inc/class.so_userinterface.inc.php
===================================================================
--- /trunk/workflow/inc/class.so_userinterface.inc.php	(revision 6478)
+++ /trunk/workflow/inc/class.so_userinterface.inc.php	(revision 6535)
@@ -289,5 +289,5 @@
 
 		/* load the employees from the area */
-		$query = "SELECT f.funcionario_id, f.organizacao_id, f.area_id, COALESCE(f.funcionario_categoria_id, 0) AS funcionario_categoria_id FROM funcionario f, funcionario_status s WHERE ((f.area_id = ?) OR (f.funcionario_id = ANY (?))) AND (f.funcionario_status_id = s.funcionario_status_id) AND (s.exibir = ?)";
+		$query = "SELECT f.funcionario_id, f.organizacao_id, f.area_id, f.funcao, to_char(f.data_admissao,'DD/MM/YYYY') as data_admissao, COALESCE(f.funcionario_categoria_id, 0) AS funcionario_categoria_id FROM funcionario f, funcionario_status s WHERE ((f.area_id = ?) OR (f.funcionario_id = ANY (?))) AND (f.funcionario_status_id = s.funcionario_status_id) AND (s.exibir = ?)";
 		$result = $this->db->query($query, array($areaID, $supervisors, 'S'));
 
@@ -301,5 +301,10 @@
 			for ($j = 0; $j < $result->_numOfFields; $j++)
 				unset($employees[$i][$j]);
-			
+			if (!$this->authorized || !isset($employees[$i]['funcao']))
+				$employees[$i]['funcao'] = '';
+			else
+				$employees[$i]['funcao'] = utf8_encode($employees[$i]['funcao']);	
+			if (!$this->authorized || !isset($employees[$i]['data_admissao']))
+				$employees[$i]['data_admissao'] = '';
 			$employees[$i]['cn'] = '';
 			$employees[$i]['telephoneNumber'] = '';
Index: /trunk/workflow/js/userinterface/orgchartPrint.js
===================================================================
--- /trunk/workflow/js/userinterface/orgchartPrint.js	(revision 6479)
+++ /trunk/workflow/js/userinterface/orgchartPrint.js	(revision 6535)
@@ -88,10 +88,10 @@
 	if (showUserPhoto){
 		var content = '<img src="workflow/showUserPicture.php?userID=' + areas[area_id].employees[user_id].funcionario_id + '"/>';
-		element.append($('<td>' + content + '</td>').css('width', '8%'));
+		element.append($('<td valign="top">' + content + '</td>').css('width', '8%'));
 	}
 
 	/* name: first column */
 	element.append(
-				$('<td></td>')
+				$('<td valign="top"></td>')
 					.append(
 						$('<span></span>')
@@ -99,5 +99,5 @@
 							.append(areas[area_id].employees[user_id].cn)
 						)
-							.css('width', '30%')
+							.css('width', '23.5%')
 			);
 
@@ -106,11 +106,10 @@
 		element.append(
 						$('<td>' + areas[area_id].sigla + '</td>')
-							.css('width', '10%')
 					);
 
 	/* login: show uid attribute */
 	element.append(
-					$('<td>' + areas[area_id].employees[user_id].uid + '</td>')
-						.css('width', '15%')
+					$('<td valign="top">' + areas[area_id].employees[user_id].uid + '</td>')
+						.css('width', '11%')
 					)
 					
@@ -118,19 +117,32 @@
 	/* telephone: last column */
 	element.append(
-					$('<td>' + areas[area_id].employees[user_id].telephoneNumber + '</td>')
-						.css('width', '15%')
+					$('<td valign="top">' + areas[area_id].employees[user_id].telephoneNumber + '</td>')
+						.css('width', '9.75%')
 					)
 					
 	/* VÃ­nculo: show cargo vÃ­nculo */
 	element.append(
-					$('<td>' + areas[area_id].employees[user_id].vinculo + '</td>')
-						.css('width', '15%')
+					$('<td valign="top">' + areas[area_id].employees[user_id].vinculo + '</td>')
+						.css('width', '9%')
 					)
 
 	/* Cargo: show cargo attribute */
 	element.append(
-					$('<td>' + areas[area_id].employees[user_id].cargo + '</td>')
-						.css('width', '15%')
-					)
+					$('<td valign="top">' + areas[area_id].employees[user_id].cargo + '</td>')
+						.css('width', '12.5%')
+					)
+					
+		/* data_admissao: show data_admissao attribute */
+	element.append(
+					$('<td valign="top">' + areas[area_id].employees[user_id].data_admissao + '</td>')
+						.css('width', '6.75%')
+					)
+					
+	/* Funcao: show funcao attribute */
+	element.append(
+				$('<td> ' + areas[area_id].employees[user_id].funcao + ' </td>')
+						.css('width', '26%')
+					)
+
 
 				.addClass('employees');
Index: /trunk/workflow/js/orgchart/organization.js
===================================================================
--- /trunk/workflow/js/orgchart/organization.js	(revision 6490)
+++ /trunk/workflow/js/orgchart/organization.js	(revision 6535)
@@ -703,11 +703,11 @@
 	content += '<a href="javascript:void(0)" onclick="openParticipants(\'funcionario_id\', \'uid=1&hidegroups=1\');" id="addEmployeeLink"><img border="0" width="16" height="16" src="workflow/templateFile.php?file=images/add_user.png" /></a>';
 	content += '</td></tr>';
-	content += '<tr><td><label for="apelido">Apelido</label></td><td><input type="text" size="20" maxlength="20" name="apelido" id="apelido"/></td></tr>';
+	content += '<tr><td><label for="apelido">Apelido</label></td><td><input type="text" size="20" maxlength="20" name="apelido" id="apelido" value=""/></td></tr>';
 	content += '<tr><td><label for="funcionario_status_id">Status</label></td><td id="comboStatus"><i>carregando</i></td></tr>';
 	content += '<tr><td><label for="funcionario_categoria_id">Categoria</label></td><td id="comboFuncionarioCategoria"><i>carregando</i></td></tr>';
 	content += '<tr><td><label for="cargo_id">Cargo</label></td><td id="comboCargo"><i>carregando</i></td></tr>';
-	content += '<tr><td><label for="funcao">Função</label></td><td><input type="text" size="50" maxlength="200" name="funcao" id="funcao"/></td></tr>';
-	content += '<tr><td><label for="data_admissao">Data de admissão</label></td><td><input type="text" name="data_admissao" id="data_admissao" size="15" onkeypress="return formatDateField(event, this);" /></td></tr>';
-	content += '<tr><td><label for="titulo">T&iacute;tulo</label></td><td><input type="text" size="30" name="titulo" id="titulo"/></td></tr>';
+	content += '<tr><td><label for="funcao">Função</label></td><td><input type="text" size="50" maxlength="200" name="funcao" id="funcao" value=""/></td></tr>';
+	content += '<tr><td><label for="data_admissao">Data de admissão</label></td><td><input type="text" name="data_admissao" id="data_admissao" value="" size="15" onkeypress="return formatDateField(event, this);" /></td></tr>';
+	content += '<tr><td><label for="titulo">T&iacute;tulo</label></td><td><input type="text" size="30" name="titulo" id="titulo" value=""/></td></tr>';
 
 	content += '<tr><td><label for="nivel">Nível</label></td><td><input type="text" size="3" name="nivel" id="nivel"/></td></tr>';